// Copyright (C) 2005 Christian Mendl

#include "str.h"
#include <stdlib.h>
#include <stdarg.h>
#include <stdio.h>


Str& Str::operator+= (const char *right)
{
	int lengthLeft = Length();
	int lengthRight = (int)strlen(right);

	data.Grow(lengthRight);
	memcpy(data.Data() + lengthLeft, right, (lengthRight+1)*sizeof(char));	// copy terminating character

	return *this;
}

Str& Str::operator+= (const Str& right)
{
	int lengthLeft = Length();

	data.Grow(right.Length());
	memcpy(data.Data() + lengthLeft, right.CStr(), right.data.NumBytes());	// copy terminating character

	return *this;
}


Str operator+ (const Str& left, const Str& right)
{
	Str ret(left.Length() + right.Length());

	memcpy(ret.CStr(), left.CStr(), left.Length()*sizeof(char));
	memcpy(ret.CStr() + left.Length(), right.CStr(), right.data.NumBytes());	// copy terminating character

	return ret;
}


char *Str::VarArg(const char *s, ...)
{
	va_list argptr;
	va_start(argptr, s);

	static char buf[16384];
	vsprintf(buf, s, argptr);

	va_end(argptr);

	return buf;
}
