#ifndef TIMER_H
#define TIMER_H

#include <windows.h>


class Timer
{

 public:

	Timer();
	double GetTime();

 private:

	double tickTime;	// in seconds
	LARGE_INTEGER startTime;
	LARGE_INTEGER currentTime;
};


inline Timer::Timer()
{
	LARGE_INTEGER ticksPerSec;
	QueryPerformanceFrequency(&ticksPerSec);
	tickTime = 1.0 / ticksPerSec.QuadPart;

	QueryPerformanceCounter(&startTime);
}

inline double Timer::GetTime()
{
	QueryPerformanceCounter(&currentTime);
	return (currentTime.QuadPart - startTime.QuadPart) * tickTime;
}



#endif
